> ## Documentation Index
> Fetch the complete documentation index at: https://docs.voiceflow.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Interact - legacy (stream)

> <Note>This endpoint is deprecated. Use the [Interact (stream)](/api-reference/conversation/interact-stream) endpoint instead. This legacy endpoint will continue to work for now, and we'll communicate a timeline for removal when one is available. We recommend migrating as soon as possible.</Note>
Returns a stream of trace events followed by an end event using [SSE](https://en.wikipedia.org/wiki/Server-sent_events).



## OpenAPI

````yaml /specs/general-runtime/openapi.public.json post /v2/project/{projectID}/user/{userID}/interact/stream
openapi: 3.0.0
info:
  title: General-runtime
  description: Voiceflow runtime service
  version: 1.0.0
  contact: {}
servers:
  - url: https://general-runtime.voiceflow.com
security: []
paths:
  /v2/project/{projectID}/user/{userID}/interact/stream:
    post:
      tags:
        - Conversation
        - Public-Docs
      summary: Interact - legacy (stream)
      description: >-
        <Note>This endpoint is deprecated. Use the [Interact
        (stream)](/api-reference/conversation/interact-stream) endpoint instead.
        This legacy endpoint will continue to work for now, and we'll
        communicate a timeline for removal when one is available. We recommend
        migrating as soon as possible.</Note>

        Returns a stream of trace events followed by an end event using
        [SSE](https://en.wikipedia.org/wiki/Server-sent_events).
      operationId: DialogManagementController_interactStream
      parameters:
        - name: projectID
          required: true
          in: path
          description: The ID of the Voiceflow project to interact with.
          schema:
            description: The ID of the Voiceflow project to interact with.
            type: string
        - name: userID
          required: true
          in: path
          schema:
            description: An ID which uniquely identifies the user having the conversation.
            type: string
        - name: modality
          required: false
          in: query
          schema:
            description: Certain features are only available depending on your modality.
            type: string
            enum:
              - voice
              - chat
              - api
            x-enumNames:
              - VOICE
              - CHAT
              - API
        - name: environment
          required: false
          in: query
          schema:
            description: Which environment to target within the project.
            type: string
            default: development
        - name: audio_events
          required: false
          in: query
          schema:
            description: >-
              If enabled, the configured speech-to-text provider will be invoked
              to convert system response text to audio. Audio traces will be
              returned from the server.
            type: boolean
        - name: audio_encoding
          required: false
          in: query
          schema:
            description: >-
              When `audio_events` are enabled, selects the encoding of audio
              traces returned by the server.
            type: string
            enum:
              - audio/mp3
              - audio/x-mulaw
              - audio/pcm
            x-enumNames:
              - MP3
              - MULAW
              - PCM
            default: audio/mp3
        - name: completion_events
          required: false
          in: query
          schema:
            description: >-
              When enabled, LLM traces will be broken up into streamed-in chunks
              -
              [documentation](/api-reference/conversations-api/completion-events)
            type: boolean
        - name: userTimezone
          required: false
          in: query
          schema:
            description: The timezone experienced by the user in this conversation.
            type: string
        - name: versionVariant
          required: false
          in: query
          schema:
            type: string
        - name: state
          required: false
          in: query
          schema:
            description: >-
              When enabled, conversation state is returned in response to each
              interaction.
            type: boolean
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                action:
                  description: >-
                    Start a new conversation with a `launch` action or reply to
                    a message with the `text` action.
                  oneOf:
                    - description: Send a launch request to start a new conversation.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - launch
                        payload:
                          type: object
                          properties:
                            persona:
                              type: string
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                    - description: Send the user response as a raw text payload.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - text
                        payload:
                          type: string
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          properties:
                            source:
                              type: string
                      required:
                        - type
                        - payload
                    - description: >-
                        Actions are self-describing operations with an
                        associated payload.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - action
                        payload:
                          type: object
                          properties:
                            actions:
                              type: array
                              items:
                                type: object
                                properties:
                                  type:
                                    type: string
                                  payload: {}
                                required:
                                  - type
                                  - payload
                            label:
                              type: string
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                    - description: Trigger a specific intent from your conversation model.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - intent
                        payload:
                          type: object
                          properties:
                            actions:
                              type: array
                              items:
                                type: object
                                properties:
                                  type:
                                    type: string
                                  payload: {}
                                required:
                                  - type
                                  - payload
                            label:
                              type: string
                            data:
                              type: object
                              additionalProperties: {}
                            query:
                              type: string
                              default: ''
                            entities:
                              type: array
                              items:
                                type: object
                                properties:
                                  name:
                                    type: string
                                  value:
                                    type: string
                                  query:
                                    type: string
                                  verboseValue:
                                    type: array
                                    items:
                                      type: object
                                      properties:
                                        rawText:
                                          type: string
                                        canonicalText:
                                          type: string
                                        startIndex:
                                          type: number
                                      required:
                                        - rawText
                                        - canonicalText
                                        - startIndex
                                required:
                                  - name
                                  - value
                              default: []
                            intent:
                              type: object
                              properties:
                                name:
                                  type: string
                              required:
                                - name
                            confidence:
                              type: number
                          required:
                            - intent
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                        - payload
                    - description: Events are triggers with an associated payload.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - event
                        payload:
                          type: object
                          properties:
                            actions:
                              type: array
                              items:
                                type: object
                                properties:
                                  type:
                                    type: string
                                  payload: {}
                                required:
                                  - type
                                  - payload
                            label:
                              type: string
                            event:
                              type: object
                              properties:
                                name:
                                  type: string
                              required:
                                - name
                          required:
                            - event
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                        - payload
                    - description: >-
                        Continue the conversation by traveling down the
                        specified path.
                      type: object
                      properties:
                        type:
                          type: string
                        payload:
                          type: object
                          properties:
                            actions:
                              type: array
                              items:
                                type: object
                                properties:
                                  type:
                                    type: string
                                  payload: {}
                                required:
                                  - type
                                  - payload
                            label:
                              type: string
                          required:
                            - label
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                        - payload
                    - description: >-
                        Represents the user failing to reply, typically sent
                        after a reasonable timeout.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - no-reply
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                    - description: Similar to the `text` action.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - message
                        payload:
                          type: object
                          properties:
                            message:
                              type: string
                          required:
                            - message
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                        - payload
                    - description: Sent to indicate the conversation has been ended.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - end
                        payload:
                          type: object
                          properties:
                            reason:
                              type: string
                          required:
                            - reason
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                    - description: >-
                        Represents the result of a dial-tone input, used for
                        phone calls.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - dtmf
                        payload:
                          type: string
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                        - payload
                    - description: Sent to interact with a connected live agent.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - live-agent-handoff
                        payload:
                          oneOf:
                            - type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - message
                                message:
                                  type: string
                              required:
                                - type
                                - message
                            - type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - file_upload
                                files:
                                  type: array
                                  minItems: 1
                                  items:
                                    type: object
                                    properties:
                                      id:
                                        type: string
                                        minLength: 1
                                      name:
                                        type: string
                                      size:
                                        type: number
                                      type:
                                        type: string
                                      status:
                                        type: string
                                        enum:
                                          - uploaded
                                          - failed
                                      metadata:
                                        type: object
                                        additionalProperties: {}
                                    required:
                                      - id
                                      - name
                                      - size
                                      - type
                              required:
                                - type
                                - files
                            - type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - continue_conversation
                              required:
                                - type
                            - type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - return_to_voiceflow
                              required:
                                - type
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                        - payload
                    - description: Represents an non-system-defined action.
                      type: object
                      properties:
                        type:
                          type: string
                        payload:
                          type: object
                          properties:
                            actions:
                              type: array
                              items:
                                type: object
                                properties:
                                  type:
                                    type: string
                                  payload: {}
                                required:
                                  - type
                                  - payload
                            label:
                              type: string
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                    - description: >-
                        Legacy intent request type that `general-runtime`
                        expects Alexa to send
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - intent
                        payload:
                          type: object
                          properties:
                            actions:
                              type: array
                              items:
                                type: object
                                properties:
                                  type:
                                    type: string
                                  payload: {}
                                required:
                                  - type
                                  - payload
                            label:
                              type: string
                            data:
                              type: object
                              additionalProperties: {}
                            query:
                              type: string
                              default: ''
                            entities:
                              type: array
                              items:
                                type: object
                                properties:
                                  name:
                                    type: string
                                  value:
                                    type: string
                                  query:
                                    type: string
                                  verboseValue:
                                    type: array
                                    items:
                                      type: object
                                      properties:
                                        rawText:
                                          type: string
                                        canonicalText:
                                          type: string
                                        startIndex:
                                          type: number
                                      required:
                                        - rawText
                                        - canonicalText
                                        - startIndex
                                required:
                                  - name
                                  - value
                              default: []
                            intent:
                              type: object
                              properties:
                                name:
                                  type: string
                              required:
                                - name
                            confidence:
                              type: number
                          required:
                            - data
                            - intent
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                        - payload
                    - description: >-
                        The legacy intent request type that `general-runtime`
                        expects from its clients.
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - intent
                        payload:
                          type: object
                          properties:
                            actions:
                              type: array
                              items:
                                type: object
                                properties:
                                  type:
                                    type: string
                                  payload: {}
                                required:
                                  - type
                                  - payload
                            label:
                              type: string
                            query:
                              type: string
                              default: ''
                            entities:
                              type: array
                              items:
                                type: object
                                properties:
                                  name:
                                    type: string
                                  value:
                                    type: string
                                  query:
                                    type: string
                                  verboseValue:
                                    type: array
                                    items:
                                      type: object
                                      properties:
                                        rawText:
                                          type: string
                                        canonicalText:
                                          type: string
                                        startIndex:
                                          type: number
                                      required:
                                        - rawText
                                        - canonicalText
                                        - startIndex
                                required:
                                  - name
                                  - value
                              default: []
                            intent:
                              type: object
                              properties:
                                name:
                                  type: string
                              required:
                                - name
                            confidence:
                              type: number
                          required:
                            - intent
                        diagramID:
                          type: string
                        time:
                          type: number
                        metadata:
                          type: object
                          additionalProperties: {}
                      required:
                        - type
                        - payload
                  nullable: true
                variables:
                  description: Set variables for the next turn of the conversation.
                  type: object
                  additionalProperties: {}
                sessionID:
                  description: Unique ID of the conversation session.
                  type: string
              required:
                - action
      responses:
        '200':
          content:
            text/event-stream:
              schema:
                oneOf:
                  - description: >-
                      Traces contain responses, media and metadata generated by
                      the conversation runtime.
                    type: object
                    properties:
                      id:
                        type: string
                      type:
                        type: string
                        enum:
                          - event
                      event:
                        type: string
                        enum:
                          - trace
                      data:
                        oneOf:
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - audio
                              paths:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    label:
                                      type: string
                                    event:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                        payload: {}
                                        diagramID:
                                          type: string
                                        time:
                                          type: number
                                        metadata:
                                          type: object
                                          additionalProperties: {}
                                      required:
                                        - type
                              defaultPath:
                                type: number
                              time:
                                type: number
                              turnID:
                                type: string
                              handleID:
                                type: string
                              payload:
                                oneOf:
                                  - type: object
                                    properties:
                                      state:
                                        type: string
                                        enum:
                                          - start
                                      messageID:
                                        type: string
                                      delay:
                                        type: number
                                    required:
                                      - state
                                      - messageID
                                  - type: object
                                    properties:
                                      state:
                                        type: string
                                        enum:
                                          - content
                                      content:
                                        type: string
                                      encoding:
                                        type: string
                                        enum:
                                          - audio/mp3
                                          - audio/x-mulaw
                                          - audio/pcm
                                        x-enumNames:
                                          - MP3
                                          - MULAW
                                          - PCM
                                      duration:
                                        type: number
                                    required:
                                      - state
                                      - content
                                      - encoding
                                  - type: object
                                    properties:
                                      state:
                                        type: string
                                        enum:
                                          - end
                                    required:
                                      - state
                            required:
                              - type
                              - payload
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - speak
                              paths:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    label:
                                      type: string
                                    event:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                        payload: {}
                                        diagramID:
                                          type: string
                                        time:
                                          type: number
                                        metadata:
                                          type: object
                                          additionalProperties: {}
                                      required:
                                        - type
                              defaultPath:
                                type: number
                              time:
                                type: number
                              turnID:
                                type: string
                              handleID:
                                type: string
                              payload:
                                type: object
                                properties:
                                  ai:
                                    type: boolean
                                  message:
                                    type: string
                                  type:
                                    type: string
                                    enum:
                                      - audio
                                      - message
                                    x-enumNames:
                                      - AUDIO
                                      - MESSAGE
                                  src:
                                    type: string
                                    nullable: true
                                  voice:
                                    type: string
                                  isPrompt:
                                    type: boolean
                                required:
                                  - message
                                  - type
                            required:
                              - type
                              - payload
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - stream
                              paths:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    label:
                                      type: string
                                    event:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                        payload: {}
                                        diagramID:
                                          type: string
                                        time:
                                          type: number
                                        metadata:
                                          type: object
                                          additionalProperties: {}
                                      required:
                                        - type
                              defaultPath:
                                type: number
                              time:
                                type: number
                              turnID:
                                type: string
                              handleID:
                                type: string
                              payload:
                                type: object
                                properties:
                                  src:
                                    type: string
                                  token:
                                    type: string
                                  action:
                                    type: string
                                    enum:
                                      - LOOP
                                      - PLAY
                                      - PAUSE
                                      - END
                                    x-enumNames:
                                      - LOOP
                                      - PLAY
                                      - PAUSE
                                      - END
                                  loop:
                                    type: boolean
                                  title:
                                    type: string
                                  iconImage:
                                    type: string
                                  description:
                                    type: string
                                  backgroundImage:
                                    type: string
                                required:
                                  - src
                                  - token
                                  - action
                            required:
                              - type
                              - payload
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - block
                              paths:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    label:
                                      type: string
                                    event:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                        payload: {}
                                        diagramID:
                                          type: string
                                        time:
                                          type: number
                                        metadata:
                                          type: object
                                          additionalProperties: {}
                                      required:
                                        - type
                              defaultPath:
                                type: number
                              time:
                                type: number
                              turnID:
                                type: string
                              handleID:
                                type: string
                              payload:
                                type: object
                                properties:
                                  blockID:
                                    type: string
                                required:
                                  - blockID
                            required:
                              - type
                              - payload
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - cardV2
                              paths:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    label:
                                      type: string
                                    event:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                        payload: {}
                                        diagramID:
                                          type: string
                                        time:
                                          type: number
                                        metadata:
                                          type: object
                                          additionalProperties: {}
                                      required:
                                        - type
                              defaultPath:
                                type: number
                              time:
                                type: number
                              turnID:
                                type: string
                              handleID:
                                type: string
                              payload:
                                type: object
                                properties:
                                  ref:
                                    oneOf:
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - node
                                          nodeID:
                                            type: string
                                          nodeType:
                                            type: string
                                          diagramID:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - nodeType
                                          - diagramID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - agent
                                          nodeID:
                                            type: string
                                          agentID:
                                            type: string
                                          diagramID:
                                            type: string
                                          agentName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - agentID
                                          - diagramID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - prompt
                                          nodeID:
                                            type: string
                                          promptID:
                                            type: string
                                          diagramID:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - promptID
                                          - diagramID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - api-tool
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          apiToolID:
                                            type: string
                                          apiToolName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - apiToolID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - function
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          functionID:
                                            type: string
                                          functionName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - functionID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - integration-tool
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          diagramName:
                                            type: string
                                          integrationToolName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - integrationToolName
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - mcp-integration-tool
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          mcpToolName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - mcpToolName
                                  title:
                                    type: string
                                  buttons:
                                    type: array
                                    items:
                                      type: object
                                      properties:
                                        name:
                                          type: string
                                        request:
                                          type: object
                                          properties:
                                            type:
                                              type: string
                                            payload: {}
                                            diagramID:
                                              type: string
                                            time:
                                              type: number
                                            metadata:
                                              type: object
                                              additionalProperties: {}
                                          required:
                                            - type
                                      required:
                                        - name
                                  imageUrl:
                                    type: string
                                    nullable: true
                                  messageID:
                                    type: string
                                  description:
                                    type: object
                                    properties:
                                      text:
                                        type: string
                                      slate:
                                        type: array
                                        items: {}
                                    required:
                                      - text
                                required:
                                  - title
                                  - buttons
                                  - imageUrl
                                  - description
                            required:
                              - type
                              - payload
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - carousel
                              paths:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    label:
                                      type: string
                                    event:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                        payload: {}
                                        diagramID:
                                          type: string
                                        time:
                                          type: number
                                        metadata:
                                          type: object
                                          additionalProperties: {}
                                      required:
                                        - type
                              defaultPath:
                                type: number
                              time:
                                type: number
                              turnID:
                                type: string
                              handleID:
                                type: string
                              payload:
                                type: object
                                properties:
                                  ref:
                                    oneOf:
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - node
                                          nodeID:
                                            type: string
                                          nodeType:
                                            type: string
                                          diagramID:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - nodeType
                                          - diagramID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - agent
                                          nodeID:
                                            type: string
                                          agentID:
                                            type: string
                                          diagramID:
                                            type: string
                                          agentName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - agentID
                                          - diagramID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - prompt
                                          nodeID:
                                            type: string
                                          promptID:
                                            type: string
                                          diagramID:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - promptID
                                          - diagramID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - api-tool
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          apiToolID:
                                            type: string
                                          apiToolName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - apiToolID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - function
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          functionID:
                                            type: string
                                          functionName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - functionID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - integration-tool
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          diagramName:
                                            type: string
                                          integrationToolName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - integrationToolName
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - mcp-integration-tool
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          mcpToolName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - mcpToolName
                                  cards:
                                    type: array
                                    items:
                                      type: object
                                      properties:
                                        ref:
                                          oneOf:
                                            - type: object
                                              properties:
                                                type:
                                                  type: string
                                                  enum:
                                                    - node
                                                nodeID:
                                                  type: string
                                                nodeType:
                                                  type: string
                                                diagramID:
                                                  type: string
                                                diagramName:
                                                  type: string
                                              required:
                                                - type
                                                - nodeID
                                                - nodeType
                                                - diagramID
                                            - type: object
                                              properties:
                                                type:
                                                  type: string
                                                  enum:
                                                    - agent
                                                nodeID:
                                                  type: string
                                                agentID:
                                                  type: string
                                                diagramID:
                                                  type: string
                                                agentName:
                                                  type: string
                                                diagramName:
                                                  type: string
                                              required:
                                                - type
                                                - nodeID
                                                - agentID
                                                - diagramID
                                            - type: object
                                              properties:
                                                type:
                                                  type: string
                                                  enum:
                                                    - prompt
                                                nodeID:
                                                  type: string
                                                promptID:
                                                  type: string
                                                diagramID:
                                                  type: string
                                                diagramName:
                                                  type: string
                                              required:
                                                - type
                                                - nodeID
                                                - promptID
                                                - diagramID
                                            - type: object
                                              properties:
                                                type:
                                                  type: string
                                                  enum:
                                                    - api-tool
                                                nodeID:
                                                  type: string
                                                diagramID:
                                                  type: string
                                                apiToolID:
                                                  type: string
                                                apiToolName:
                                                  type: string
                                                diagramName:
                                                  type: string
                                              required:
                                                - type
                                                - nodeID
                                                - diagramID
                                                - apiToolID
                                            - type: object
                                              properties:
                                                type:
                                                  type: string
                                                  enum:
                                                    - function
                                                nodeID:
                                                  type: string
                                                diagramID:
                                                  type: string
                                                functionID:
                                                  type: string
                                                functionName:
                                                  type: string
                                                diagramName:
                                                  type: string
                                              required:
                                                - type
                                                - nodeID
                                                - diagramID
                                                - functionID
                                            - type: object
                                              properties:
                                                type:
                                                  type: string
                                                  enum:
                                                    - integration-tool
                                                nodeID:
                                                  type: string
                                                diagramID:
                                                  type: string
                                                diagramName:
                                                  type: string
                                                integrationToolName:
                                                  type: string
                                              required:
                                                - type
                                                - nodeID
                                                - diagramID
                                                - integrationToolName
                                            - type: object
                                              properties:
                                                type:
                                                  type: string
                                                  enum:
                                                    - mcp-integration-tool
                                                nodeID:
                                                  type: string
                                                diagramID:
                                                  type: string
                                                mcpToolName:
                                                  type: string
                                                diagramName:
                                                  type: string
                                              required:
                                                - type
                                                - nodeID
                                                - diagramID
                                                - mcpToolName
                                        title:
                                          type: string
                                        buttons:
                                          type: array
                                          items:
                                            type: object
                                            properties:
                                              name:
                                                type: string
                                              request:
                                                type: object
                                                properties:
                                                  type:
                                                    type: string
                                                  payload: {}
                                                  diagramID:
                                                    type: string
                                                  time:
                                                    type: number
                                                  metadata:
                                                    type: object
                                                    additionalProperties: {}
                                                required:
                                                  - type
                                            required:
                                              - name
                                        imageUrl:
                                          type: string
                                          nullable: true
                                        messageID:
                                          type: string
                                        description:
                                          type: object
                                          properties:
                                            text:
                                              type: string
                                            slate:
                                              type: array
                                              items: {}
                                          required:
                                            - text
                                        id:
                                          type: string
                                      required:
                                        - title
                                        - buttons
                                        - imageUrl
                                        - description
                                  layout:
                                    type: string
                                    enum:
                                      - List
                                      - Carousel
                                    x-enumNames:
                                      - LIST
                                      - CAROUSEL
                                  messageID:
                                    type: string
                                required:
                                  - cards
                                  - layout
                            required:
                              - type
                              - payload
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - channel-action
                              paths:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    label:
                                      type: string
                                    event:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                        payload: {}
                                        diagramID:
                                          type: string
                                        time:
                                          type: number
                                        metadata:
                                          type: object
                                          additionalProperties: {}
                                      required:
                                        - type
                              defaultPath:
                                type: number
                              time:
                                type: number
                              turnID:
                                type: string
                              handleID:
                                type: string
                              payload:
                                type: object
                                properties:
                                  name:
                                    type: string
                                  payload:
                                    type: object
                                    additionalProperties: {}
                                required:
                                  - name
                                  - payload
                            required:
                              - type
                              - payload
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - choice
                              paths:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    label:
                                      type: string
                                    event:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                        payload: {}
                                        diagramID:
                                          type: string
                                        time:
                                          type: number
                                        metadata:
                                          type: object
                                          additionalProperties: {}
                                      required:
                                        - type
                              defaultPath:
                                type: number
                              time:
                                type: number
                              turnID:
                                type: string
                              handleID:
                                type: string
                              payload:
                                type: object
                                properties:
                                  ref:
                                    oneOf:
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - node
                                          nodeID:
                                            type: string
                                          nodeType:
                                            type: string
                                          diagramID:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - nodeType
                                          - diagramID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - agent
                                          nodeID:
                                            type: string
                                          agentID:
                                            type: string
                                          diagramID:
                                            type: string
                                          agentName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - agentID
                                          - diagramID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - prompt
                                          nodeID:
                                            type: string
                                          promptID:
                                            type: string
                                          diagramID:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - promptID
                                          - diagramID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - api-tool
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          apiToolID:
                                            type: string
                                          apiToolName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - apiToolID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - function
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          functionID:
                                            type: string
                                          functionName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - functionID
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - integration-tool
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          diagramName:
                                            type: string
                                          integrationToolName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - integrationToolName
                                      - type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - mcp-integration-tool
                                          nodeID:
                                            type: string
                                          diagramID:
                                            type: string
                                          mcpToolName:
                                            type: string
                                          diagramName:
                                            type: string
                                        required:
                                          - type
                                          - nodeID
                                          - diagramID
                                          - mcpToolName
                                  buttons:
                                    type: array
                                    items:
                                      type: object
                                      properties:
                                        name:
                                          type: string
                                        request:
                                          type: object
                                          properties:
                                            type:
                                              type: string
                                            payload: {}
                                            diagramID:
                                              type: string
                                            time:
                                              type: number
                                            metadata:
                                              type: object
                                              additionalProperties: {}
                                          required:
                                            - type
                                      required:
                                        - name
                                  messageID:
                                    type: string
                                required:
                                  - buttons
                            required:
                              - type
                              - payload
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - completion
                              paths:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    label:
                                      type: string
                                    event:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                        payload: {}
                                        diagramID:
                                          type: string
                                        time:
                                          type: number
                                        metadata:
                                          type: object
                                          additionalProperties: {}
                                      required:
                                        - type
                              defaultPath:
                                type: number
                              time:
                                type: number
                              turnID:
                                type: string
                              handleID:
                                type: string
                              payload:
                                oneOf:
                                  - type: object
                                    properties:
                                      state:
                                        type: string
                                        enum:
                                          - start
                                      ai:
                                        type: boolean
                                      sourceUrls:
                                        type: array
                                        items:
                                          type: object
                                          properties:
                                            url:
                                              type: string
                                            name:
                                              type: string
                                          required:
                                            - url
                                      delay:
                                        type: number
                                      messageID:
                                        type: string
                                      ref:
                                        oneOf:
                                          - type: object
                                            properties:
                                              type:
                                                type: string
                                                enum:
                                                  - node
                                              nodeID:
                                                type: string
                                              nodeType:
                                                type: string
                                              diagramID:
                                                type: string
                                              diagramName:
                                                type: string
                                            required:
                                              - type
                                              - nodeID
                                              - nodeType
                                              - diagramID
                                          - type: object
                                            properties:
                                              type:
                                                type: string
                                                enum:
                                                  - agent
                                              nodeID:
                                                type: string
                                              agentID:
                                                type: string
                                              diagramID:
                                                type: string
                                              agentName:
                                                type: string
                                              diagramName:
                                                type: string
                                            required:
                                              - type
                                              - nodeID
                                              - agentID
                                              - diagramID
                                          - type: object
                                            properties:
                                              type:
                                                type: string
                                                enum:
                                                  - prompt
                                              nodeID:
                                                type: string
                                              promptID:
                                                type: string
                                              diagramID:
                                                type: string
                                              diagramName:
                                                type: string
                                            required:
                                              - type
                                              - nodeID
                                              - promptID
                                              - diagramID
                                          - type: object
                                            properties:
                                              type:
                                                type: string
                                                enum:
                                                  - api-tool
                                              nodeID:
                                                type: string
                                              diagramID:
                                                type: string
                                              apiToolID:
                                                type: string
                                              apiToolName:
                                                type: string
                                              diagramName:
                                                type: string
                                            required:
                                              - type
                                              - nodeID
                                              - diagramID
                                              - apiToolID
                                          - type: object
                                            properties:
                                              type:
                                                type: string
                                                enum:
                                                  - function
                                              nodeID:
                                                type: string
                                              diagramID:
                                                type: string
                                              functionID:
                                                type: string
                                              functionName:
                                                type: string
                                              diagramName:
                                                type: string
                                            required:
                                              - type
                                              - nodeID
                                              - diagramID
                                              - functionID
                                          - type: object
                                            properties:
                                              type:
                                                type: string
                                                enum:
                                                  - integration-tool
                                              nodeID:
                                                type: string
                                              diagramID:
                                                type: string
                                              diagramName:
                                                type: string
                                              integrationToolName:
                                                type: string
                                            required:
                                              - type
                                              - nodeID
                                              - diagramID
                                              - integrationToolName
                                          - type: object
                                            properties:
                                              type:
                                                type: string
                                                enum:
                                                  - mcp-integration-tool
                                              nodeID:
                                                type: string
                                              diagramID:
                                                type: string
                                              mcpToolName:
                                                type: string
                                              diagramName:
                                                type: string
                                            required:
                                              - type
                                              - nodeID
                                              - diagramID
                                              - mcpToolName
                                    required:
[...]
